module CircDefs where

-- Metaprogramming Project
-- http://www.infosun.fmi.uni-passau.de/cl/metaprog
-- Author: Christoph A. Herrmann 
-- Copyright (C) 2006 University of Passau

import Language.Haskell.TH
import Signal

$(defHalfAdder)

defFullAdder :: Q [Dec]
defFullAdder = [d| fullAdder ~(a,b,c) = let ~(c1,s1) = halfAdder (a,b)
                                            ~(c2,s2) = halfAdder (s1,c)
                                        in (or2(c1,c2), s2)
               |]

defShRegElem :: Q [Dec]
defShRegElem = [d| shRegElem ~(write,shift,left,inp)
                     = let r = flipflop (or2(write,shift),
                                         mux(write,left,inp))
                       in (r,r)
               |]
