{-# OPTIONS -fglasgow-exts #-}
module Main where

-- Metaprogramming Project
-- http://www.infosun.fmi.uni-passau.de/cl/metaprog
-- Author: Christoph A. Herrmann 
-- Copyright (C) 2006 University of Passau

import Monad
import Language.Haskell.TH
import Value
import Signal
import Indexing
import Designs
import Conversions

main :: IO ()
main =
    let ticks  = 10
        stable = 2
        mk x   = concatMap (uncurry replicate)
                           [(stable,Just x),(ticks-stable,Nothing)]
        op1    = mk 5 ++ mk 6
        op2    = mk 3 ++ mk 7
        init   = replicate stable         I ++
                 replicate (ticks-stable) O ++
                 init
        step   = let clk = I:O:clk in clk
        op1'   = $(nums2words 4) op1
        op2'   = $(nums2words 5) op2
        ~(ready,res',tmpRes') = $(seqMult True (4,5)) (step,init,op1',op2')
        res    = $(words2nums 9) res'
        tmpRes = $(words2nums 9) tmpRes'
        in do
             print $ take 100 op1
             print $ take 100 op2
             print $ take 100 init
             print $ take 100 step
             print $ take 100 ready
             print $ take 100 res
             print $ take 100 tmpRes
             return ()
