{-# OPTIONS -fglasgow-exts #-}
module Power where

-- Metaprogramming Project
-- http://www.infosun.fmi.uni-passau.de/cl/metaprog
-- Author: Christoph A. Herrmann 
-- Copyright (C) 2006 University of Passau

import Language.Haskell.TH

power :: Num a => a -> Int -> a
power x n | n==0 = 1
          | n>0  = x * power x (n-1)

pow :: Int -> Q Exp
pow 0       = [| \x -> 1 |]
pow n | n>0 = [| \x -> x * $(pow (n-1)) x |]

prod :: Q Exp -> Int -> Q Exp
prod x 0       = [| 1 |]
prod x n | n>0 = [| $x * $(prod x (n-1)) |]

pow' :: Int -> Q Exp
pow' n = [| \x -> $(prod [|x|] n) |]

prod' x 0                 = [| 1 |]
prod' x 1                 = x
prod' x 2                 = [| $x * $x |]
prod' x n | n>0 && even n = [| let y = $(prod' x (n`div`2)) in y*y |]
          | n>0 && odd n  = [| $x * $(prod' x (n-1)) |]

powOpt :: Int -> Q Exp
powOpt n = [| \x -> $(prod' [| x |] n) |]
