module Signal where

-- Metaprogramming Project
-- http://www.infosun.fmi.uni-passau.de/cl/metaprog
-- Author: Christoph A. Herrmann 
-- Copyright (C) 2006 University of Passau

import Language.Haskell.TH
import SelZip
import Value
import ValueOpt
type Signal = [Value]

delay :: Signal -> Signal
delay s = U:s

cO, cI :: Signal
cO = O:cO
cI = I:cI

not1 :: Signal -> Signal
not1 = $(zipWithN 1 "vnot1")

and2 :: (Signal,Signal) -> Signal
and2 = $(zipWithN 2 "vand2")
nand2 = $(zipWithN 2 "vnand2")
or2   = $(zipWithN 2 "vor2")
nor2  = $(zipWithN 2 "vnor2")
xor2  = $(zipWithN 2 "vxor2")
eqv2  = $(zipWithN 2 "veqv2")

mux :: (Signal,Signal,Signal) -> Signal
mux = $(zipWithN 3 "vmux")

flipflop :: (Signal,Signal) -> Signal
flipflop (write,inp) = let out = delay (mux (write,out,inp))
                       in out
defHalfAdder :: Q [Dec]
defHalfAdder = [d| halfAdder ~(a,b) = (and2(a,b), xor2(a,b)) |]
